<?

/*
Copyright (C) 2003  Kristoffer Bergheim Ottesen

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

$start = time();

echo "MTASG 0.2b - Multi Theft Auto Statistics Generator by Wartech\n";
echo "\n";

include("config.php");

$vehiclenames = array(1 => "Ambulance", 2 => "Sentinel XS", 3 => "Stinger", 4 => "Sabre Turbo", 5 => "Cheetah", 6 => "PCJ 600", 7 => "Sanchez", 8 => "Angel", 9 => "VCN Maverick", 10 => "PCJ 600", 11 => "Maverick", 12 => "Police Maverick", 13 => "Hunter", 14 => "Bloodring Banger", 15 => "Bloodring Banger", 16 => "Bloodring Banger", 17 => "Bloodring Banger", 18 => "PCJ 600", 19 => "PCJ 600", 20 => "PCJ 600", 21 => "PCJ 600", 22 => "PCJ 600", 23 => "FBI Rancher", 24 => "Packer", 25 => "Hotring Racer", 26 => "Hotring Racer", 27 => "Hotring Racer", 28 => "Hotring Racer", 29 => "Cheetah", 30 => "Comet", 31 => "Infernus", 32 => "Mesa Grande", 33 => "Stinger", 34 => "Securicar", 35 => "Mr. Whoopee", 36 => "Sanchez", 37 => "Cheetah", 38 => "Bobcat", 39 => "Packer", 40 => "Police", 41 => "Police", 42 => "Love Fist", 43 => "Sanchez", 44 => "Faggio", 45 => "Rancher", 46 => "Sentinel XS", 47 => "Mule", 48 => "Firetruck", 49 => "Benson", 50 => "Maverick", 51 => "Freeway", 52 => "Phoenix", 53 => "Enforcer", 54 => "Burrito", 55 => "Sentinel XS", 56 => "Washington", 57 => "Maverick", 58 => "PCJ 600", 59 => "Perennial", 60 => "Mesa Grande", 61 => "Rancher", 62 => "Stinger", 63 => "Bus", 64 => "Sandking", 65 => "Sanchez", 66 => "Idaho", 67 => "Mule", 68 => "Linerunner", 69 => "Barracks OL", 70 => "Patriot", 71 => "Benson", 72 => "Deluxo", 73 => "Washington", 74 => "PCJ 600", 75 => "Comet", 76 => "Caddy", 77 => "Sanchez", 78 => "Idaho", 79 => "Rancher", 80 => "Sabre Turbo");

$lines = 0;
$totalplayers = 0;
$totalboosts = 0;
$totalpickups = 0;
$totalkills = 0;
$totalsuicides = 0;

$players = array();

echo "Parsing logfile: $logfile\n";

if(!file_exists($logfile)) {
	
	die("The specified logfile: $logfile doesn't exist\n");
	
}

$fp = fopen($logfile, "r");

if(!$fp) {
	
	die("Failed opening logfile: $logfile for reading\n");
	
}

while(!feof($fp)) {
	
	$data = fgets($fp, 1024);
	
	if(substr($data, 0, 4) == "Join") {
		
		$id = split("Join: ", $data);
		$id = split("", $id[1]);
		$id = $id[0];
		
		$name = split("Join: ", $data);
		$name = split("", $name[1]);
		$name = $name[1];
		
		$in_array = 0;
		
		foreach(array_keys($players) as $player) {
			
			if($players[$player][name] == $name) {
				
				$in_array = 1;
				
			}
			
		}
		
		if(!$in_array) {
			
			$players = array_merge($players, array(array("name" => $name, "kills" => 0, "deaths" => 0, suicides => 0, "favorite_target" => "", "favorite_target_kills" => 0, "favorite_vehicle" => "", "favorite_vehicle_boosts" => 0)));
			
			$totalplayers++;
			
		}
		
		foreach(array_keys($players) as $player) {
			
			if($players[$player][name] == $name) {
				
				$player_id = $player;
				
			}
			
		}
		
		$currentplayers[$id] = $player_id;
		
	}
	
	if(substr($data, 0, 4) == "Kill") {
		
		$id = split("Kill: ", $data);
		$id = split(" ", $id[1]);
		$id = $id[0];
		
		$target = split("Kill: ", $data);
		$target = split(" ", $target[1]);
		$target = trim($target[1]);
		
		$players[$currentplayers[$id]][kills]++;
		
		if($id == $target) {
			
			$players[$currentplayers[$id]][suicides]++;
			
			$totalsuicides++;
			
		}
		else {
			
			$kills[$currentplayers[$id]][$currentplayers[$target]]++;
			
			$totalkills++;
			
		}
		
	}
	
	if(substr($data, 0, 3) == "Veh") {
		
		$id = split("Veh: ", $data);
		$id = split(" ", $id[1]);
		$id = $id[0];
		
		$vehicle = split("Veh: ", $data);
		$vehicle = split(" ", $vehicle[1]);
		$vehicle = trim($vehicle[1]);
		
		if($vehicle >= 1 && $vehicle <= 80) {
			
			$vehicles[$currentplayers[$id]][$vehiclenames[$vehicle]]++;
			$allvehicles[$vehiclenames[$vehicle]]++;
			
			$totalboosts++;
			
		}
		
	}
	
	if(substr($data, 0, 3) == "Wea") {
		
		$id = split("Wea: ", $data);
		$id = split(" ", $id[1]);
		$id = $id[0];
		
		$weapon = split("Wea: ", $data);
		$weapon = split(" ", $weapon[1]);
		$weapon = trim($weapon[1]);
		
		$totalpickups++;
		
	}
	
	if(substr($data, 0, 5) == "Death") {
		
		$id = split("Death: ", $data);
		$id = split(" ", $id[1]);
		$id = trim($id[0]);
		
		$players[$currentplayers[$id]][deaths]++;
		
	}
	
	if(substr($data, 0, 4) == "Quit") {
		
		$id = split("Quit: ", $data);
		$id = trim($id[1]);
		
		unset($currentplayers[$id]);
		
	}
	
	$lines++;
	
}

fclose($fp);

foreach(array_keys($kills) as $kill) {
	
	arsort($kills[$kill]);
	
	$target = key($kills[$kill]);
	
	$players[$kill][favorite_target] = $players[$target][name];
	$players[$kill][favorite_target_kills] = $kills[$kill][$target];
	
}

foreach(array_keys($vehicles) as $vehicle) {
	
	arsort($vehicles[$vehicle]);
	
	$vehicle_name = key($vehicles[$vehicle]);
	
	$players[$vehicle][favorite_vehicle] = $vehicle_name;
	$players[$vehicle][favorite_vehicle_boosts] = $vehicles[$vehicle][$vehicle_name];
	
}

arsort($allvehicles);

$popular_vehicle = key($allvehicles);
$popular_vehicle_boosts = $allvehicles[$popular_vehicle];

$players2 = array();

foreach(array_keys($players) as $player) {
	
	$players2 = $players2+array($player => $players[$player][kills]-$players[$player][suicides]);
	
}

arsort($players2);

$players3 = array();

foreach(array_keys($players2) as $player2) {
	
	$players3 = array_merge($players3, array($players[$player2]));
	
}

$players = $players3;
unset($players2);
unset($players3);

$end = time();
$time = $end-$start;

$updatedtime = date("H:i:s");
$updateddate = date("d/m/Y");

$stats = "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
$stats .= "\n";
$stats .= "<html>\n";
$stats .= "<head>\n";
$stats .= "<title>MTASG 0.2b</title>\n";
$stats .= "<meta http-equiv=\"refresh\" content=\"3600\">\n";
$stats .= "<link href=\"$theme.css\" rel=\"stylesheet\">\n";
$stats .= "</head>\n";
$stats .= "<body>\n";
$stats .= "<center>\n";
$stats .= "<img src=\"logo.jpg\" alt=\"\" border=\"1\"><br><br>\n";
$stats .= "<font size=\"5\">MTASG</font><font size=\"4\"> - </font><font size=\"5\">M</font><font size=\"4\">ULTI </font><font size=\"5\">T</font><font size=\"4\">HEFT </font><font size=\"5\">A</font><font size=\"4\">UTO </font><font size=\"5\">S</font><font size=\"4\">TATISTICS </font><font size=\"5\">G</font><font size=\"4\">ENERATOR</font><br><br>\n";
$stats .= "<table cellpadding=\"1\" cellspacing=\"1\" width=\"800\" border=\"0\">\n";
$stats .= "  <tr>\n";
$stats .= "    <td width=\"800\">\n";
$stats .= "      <b>Stats</b><br><br>\n";
$stats .= "      Last updated at <b>$updatedtime</b> on <b>$updateddate</b>. <b>$lines</b> ";

if($lines == 1) {
	
	$stats .= "line";
	
}
else {
	
	$stats .= "lines";
	
}

$stats .= " were parsed in <b>$time</b> ";

if($time == 1) {
	
	$stats .= "second";
	
}
else {
	
	$stats .= "seconds";
	
}

$stats .= ". There have been <b>$totalplayers</b> ";

if($totalplayers == 1) {
	
	$stats .= "player";
	
}
else {
	
	$stats .= "players";
	
}

$stats .= " on the server, and a total of <b>$totalboosts</b> ";

if($totalboosts == 1) {
	
	$stats .= "vehicle";
	
}
else {
	
	$stats .= "vehicles";
	
}

$stats .= " has been boosted. ";

if($popular_vehicle) {
	
	$stats .= " The most popular vehicle is the <b>$popular_vehicle</b>, which has been boosted <b>$popular_vehicle_boosts</b> ";
	
	if($popular_vehicle_boosts == 1) {
		
		$stats .= "time";
		
	}
	else {
		
		$stats .= "times";
		
	}
	
	$stats .= ". ";
	
}

$stats .= "A total of <b>$totalpickups</b> ";

if($totalkills == 1) {
	
	$stats .= "weapon/powerup";
	
}
else {
	
	$stats .= "weapons/powerups";
	
}

$stats .= " has been picked up. <b>$totalkills</b> ";

if($totalkills == 1) {
	
	$stats .= "person";
	
}
else {
	
	$stats .= "people";
	
}

$stats .= " have been killed, and <b>$totalsuicides</b> ";

if($totalsuicides == 1) {
	
	$stats .= "person";
	
}
else {
	
	$stats .= "people";
	
}

$stats .= " have commited suicide.<br><br>\n";
$stats .= "      <table cellpadding=\"0\" cellspacing=\"0\" class=\"invisible\" width=\"100%\" border=\"0\">\n";
$stats .= "        <tr>\n";
$stats .= "          <td width=\"5%\">\n";
$stats .= "            <b>#</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"25%\">\n";
$stats .= "            <b>Name</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"20%\">\n";
$stats .= "            <b>Favorite Target</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"20%\">\n";
$stats .= "            <b>Favorite Vehicle</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"10%\">\n";
$stats .= "            <b>Kills</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"10%\">\n";
$stats .= "            <b>Deaths</b>\n";
$stats .= "          </td>\n";
$stats .= "          <td width=\"10%\">\n";
$stats .= "            <b>Suicides</b>\n";
$stats .= "          </td>\n";
$stats .= "        </tr>\n";

foreach(array_keys($players) as $player) {
	
	if($player < 20) {
		
		$rank = $player+1;
		$name = $players[$player][name];
		$kills = $players[$player][kills]-$players[$player][suicides];
		$deaths = $players[$player][deaths]-$players[$player][suicides];
		$suicides = $players[$player][suicides];
		$favorite_target = $players[$player][favorite_target];
		$favorite_target_kills = $players[$player][favorite_target_kills];
		$favorite_vehicle = $players[$player][favorite_vehicle];
		$favorite_vehicle_boosts = $players[$player][favorite_vehicle_boosts];
		
		if($favorite_target) {
			
			$favorite_target = "$favorite_target ($favorite_target_kills)";
			
		}
		else {
			
			$favorite_target = "-";
			
		}
		
		if($favorite_vehicle) {
			
			$favorite_vehicle = "$favorite_vehicle ($favorite_vehicle_boosts)";
			
		}
		else {
			
			$favorite_vehicle = "-";
			
		}
		
		$stats .= "        <tr>\n";
		$stats .= "          <td width=\"5%\">\n";
		$stats .= "            $rank\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"25%\">\n";
		$stats .= "            $name\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"20%\">\n";
		$stats .= "            $favorite_target\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"20%\">\n";
		$stats .= "            $favorite_vehicle\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"10%\">\n";
		$stats .= "            $kills\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"10%\">\n";
		$stats .= "            $deaths\n";
		$stats .= "          </td>\n";
		$stats .= "          <td width=\"10%\">\n";
		$stats .= "            $suicides\n";
		$stats .= "          </td>\n";
		$stats .= "        </tr>\n";
		
	}
	
}

$stats .= "      </table>\n";
$stats .= "    </td>\n";
$stats .= "  </tr>\n";
$stats .= "</table><br>\n";
$stats .= "Stats generated with <a href=\"http://mtasg.blackedge.org/\">MTASG 0.2b</a> by Wartech\n";
$stats .= "</center>\n";
$stats .= "</body>\n";
$stats .= "</html>";

echo "Done! $lines lines parsed in $time ";

if($time == 1) {
	
	echo "second";
	
}
else {
	
	echo "seconds";
	
}

echo "\n";

echo "Saving statsfile: $statsfile\n";

$fp = fopen($statsfile, "w");

if(!$fp) {
	
	die("Failed opening statsfile: $statsfile for writing\n");
	
}

fwrite($fp, $stats);
fclose($fp);

echo "Done! $statsfile saved\n";

?>
